import turtle as t
import math            
import random

# 초기값 설정
dg = 20                    # 꽃잎 벌림각
Np = 7                     # 꽃잎의 수 
h = 0                        # 처음 꽃잎 방향
Nf = 100                    # 꽃의 수
t.colormode(255)    # 칼라모드 설정

t.hideturtle()            # 펜을 숨김
t.speed(0)                # 속도를 빠르게 


def petal(dg, length, h):               # 기본형 꽃잎 함수 정의 
    t.setheading(h)
    t.left(dg)
    t.forward(length)
    c = length*math.sin(math.radians(dg))  
    t.right(dg)
    t.circle(-c, 180)
    t.right(dg)
    t.forward(length)


def petal_heart(dg, length, h):   # 하트형 꽃잎 함수 정의 
    t.setheading(h)
    t.left(dg)
    t.forward(length)
    c = length*math.sin(math.radians(dg))
    t.right(dg)
    t.circle(-c/2, 180)
    t.setheading(h)        
    t.circle(-c/2, 180)
    t.right(dg)
    t.forward(length)


def petal_R_heart(dg, length, h):   # 역하트형 꽃잎 함수 정의 
    t.setheading(h)
    t.left(dg)
    t.forward(length)
    c = length*math.sin(math.radians(dg))
    t.right(dg)
    t.circle(-c/2, -180)
    t.setheading(h)        
    t.circle(-c/2, -180)
    t.right(dg)
    t.forward(length)


def make_flower(h, Np, x, y, r, g, b):
     t.penup()
     t.setposition(x, y)
     t.fillcolor(r, g, b)
     t.begin_fill() 
     for a in range(0, Np):
          t.pendown()
          petal(dg, length, h)          
          h = h + 360/Np
          t.setheading(h)
     t.end_fill()    


for i in range(0,Nf):
     x = random.randint(-300, 300)
     y = random.randint(-200, 200)
     r = random.randint(200, 250)
     g = random.randint(200, 250)
     b = random.randint(200, 250)
     length = random.randint(30, 60)  # 꽃잎의 길이를 30~60 사이로 설정 

     t.pencolor(255, 255, 255)             # 펜색 설정 
     make_flower(h, Np, x, y, r, g, b)
     
